%global _python_bytecompile_errors_terminate_build 0
%global perlversion %(perl -e '$_ = int\(\($] - 5\) * 1000\); print')
%global service_name stafproc

Summary: Software Testing Automation Framework
Name: STAF
Version: 3.4.26
Release: 4
License: EPL
Group:   System Environment/Daemons
Source0: STAF3426-src.tar.gz
Source1: startstaf.service.in
Source2: stafproc.init.in
#Source2: jython-installer-2.5.4-rc1.jar
Patch0:  0001-Use-OpenSSL-API-compatible-with-OpenSSL-1.1.0.patch
URL: http://staf.sourceforge.net/
ExclusiveArch: x86_64 %ix86

BuildRequires: gcc-c++
BuildRequires: make
BuildRequires: perl-devel
BuildRequires: python-devel
BuildRequires: symlinks

%if 0%{?rhel} == 5
%global __python /usr/bin/python
%global python_version %(%{__python} -c "import sys; sys.stdout.write(sys.version[:3])")
%global java_verion 1.7
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: openssl101e-devel
Requires:  java-1.7.0-openjdk
Requires(post): chkconfig
Requires(preun): chkconfig
# This is for /sbin/service
Requires(preun): initscripts
Requires(postun): initscripts

%else
BuildRequires: openssl-devel
%global java_verion 1.8
BuildRequires: systemd
Requires:  java-1.8.0-openjdk-headless
%endif

BuildRequires: java-%{java_verion}.0-openjdk-devel
Requires:  perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description
The Software Testing Automation Framework (STAF) is an open source,
multi-platform, multi-language framework designed around the idea of reusable
components, called services (such as process invocation, resource management,
logging, and monitoring). STAF removes the tedium of building an automation
infrastructure, thus enabling you to focus on building your automation
solution. The STAF framework provides the foundation upon which to build
higher level solutions, and provides a pluggable approach supported across a
large variety of platforms and languages.


%prep
%setup -n src/staf
%patch0 -p 1
%if 0%{?rhel} == 5
mkdir -p openssl/include
mkdir openssl/lib
ln -s /usr/include/openssl101e/openssl openssl/include/openssl
ln -s %{_libdir}/libcrypto.so.1.0.1e openssl/lib/libcrypto.so.1.0.1e
ln -s %{_libdir}/libssl.so.1.0.1e openssl/lib/libssl.so.1.0.1e
ln -s libssl.so.1.0.1e openssl/lib/libssl.so.10
ln -s libssl.so.1.0.1e openssl/lib/libssl.so
ln -s libcrypto.so.1.0.1e openssl/lib/libcrypto.so.10
ln -s libcrypto.so.1.0.1e openssl/lib/libcrypto.so

%endif

#mkdir jython
#java -jar %{SOURCE2} -s -d $PWD/jython
if [ ! -d lang/perl/perl5%{perlversion} ]; then
   mkdir lang/perl/perl5%{perlversion}
   cp lang/perl/perl5{20,%{perlversion}}/makefile.perl
   sed -i -e 's/520/5%{perlversion}/g' lang/perl/perl5%{perlversion}/makefile.perl
fi

%build
# let's go and set a lot of environment vars (http://staf.sourceforge.net/current/stafdg.html)
%if 0%{?rhel} == 5
#export STAF_USE_SSL=
export OPENSSL_ROOT=$PWD/openssl
export OPENSSL_LIBDIRS=$PWD/openssl/lib
export OPENSSL_VERSION=$(readelf -d %{_libdir}/openssl101e/libssl.so|grep SONAME|perl -ne '/\.([.\d]+)\]/; print $1')
%else
export OPENSSL_ROOT=%{_prefix}
export OPENSSL_LIBDIRS=%{_libdir}
export OPENSSL_VERSION=$(readelf -d %{_libdir}/libssl.so|grep SONAME|perl -ne '/\.([.\d]+)\]/; print $1')
%endif

%ifarch %ix86
    export OS_NAME=linux
%else
    export OS_NAME=linuxamd64
%endif
export BUILD_TYPE=retail
export PROJECTS="staf connprov* python perl java"
%if 0%{?rhel} == 5
export PYTHON_BUILD_V24=1
export PYTHON_BUILD_V27=0
export PYTHON_V24_ROOT=%{_prefix}
export PYTHON_V24_INCLUDEDIRS="${PYTHON_V24_ROOT}/include/python%{python_version}"
export PYTHON_V24_LIBDIRS=${PYTHON_V24_ROOT}/%{_lib}/python%{python_version}/config
export PYTHON_V24_LIBS=python%{python_version}
%else
export PYTHON_BUILD_V24=0
export PYTHON_BUILD_V27=1
export PYTHON_V27_ROOT=%{_prefix}
export PYTHON_V27_INCLUDEDIRS="${PYTHON_V27_ROOT}/include/python%{python_version}"
export PYTHON_V27_LIBDIRS=${PYTHON_V27_ROOT}/%{_lib}/python%{python_version}/config
export PYTHON_V27_LIBS=python%{python_version}
%endif
export PYTHON_BUILD_V22=0
export PYTHON_BUILD_V23=0
export PYTHON_BUILD_V25=0
export PYTHON_BUILD_V26=0
export PYTHON_BUILD_V30=0
export PYTHON_BUILD_V31=0
export PYTHON_BUILD_V32=0
export PYTHON_BUILD_V33=0
export PYTHON_BUILD_V34=0
export PYTHON_BUILD_V35=0
export PERL_BUILD_V58=0
export PERL_BUILD_V56=0
export PERL_BUILD_V510=0
export PERL_BUILD_V512=0
export PERL_BUILD_V514=0
export PERL_BUILD_V518=0
export PERL_BUILD_V516=0
export PERL_BUILD_V520=0
export PERL_BUILD_V5%{perlversion}=1
export PERL_V5%{perlversion}_ROOT=%{perl_archlib}
export PERL_V5%{perlversion}_INCLUDEDIRS=$PERL_V5%{perlversion}_ROOT/CORE
export PERL_V5%{perlversion}_LIBDIRS=$PERL_V5%{perlversion}_ROOT/CORE
export PERL_V5%{perlversion}_LIBS=perl
%if 0%{?rhel} == 5
export PERL_V5%{perlversion}_DYNALOADER=$PERL_V5%{perlversion}_ROOT/auto/DynaLoader/DynaLoader.a
%endif
export STAFCODEPAGE=%{_libdir}/staf/codepage
export JAVA_DRIVE=d
#export JYTHON_ROOT=$PWD/jython
export JAVA_LIBS=jvm
export JAVA_VERSION=1.8
export JAVA_BUILD_V11=0
export JAVA_BUILD_V12=1
export JAVA_V12_ROOT=%{java_home}
export JAVA_V12_LIBDIRS=$JAVA_V12_ROOT/lib
make

%install
%if 0%{?rhel} == 5
#export STAF_USE_SSL=
export OPENSSL_ROOT=$PWD/openssl
export OPENSSL_LIBDIRS=$PWD/openssl/lib
%else
export OPENSSL_LIBDIRS=%{_libdir}
export OPENSSL_ROOT=%{_prefix}
%endif

%ifarch %ix86
    export OS_NAME=linux
%else
    export OS_NAME=linuxamd64
%endif
cd ${RPM_BUILD_DIR}/rel/${OS_NAME}/staf/retail/lib/
if [ ! -d "IPv4" ]; then mkdir IPv4; fi
cp libSTAF.so IPv4/.
cp libSTAFTCP.so IPv4/.
cd ${RPM_BUILD_DIR}/rel/${OS_NAME}/staf/retail/
STAF_ROOT=${RPM_BUILD_ROOT}%{_libdir}/staf
#./STAFInst -target ${STAF_ROOT} -bin ${RPM_BUILD_ROOT}%{_bindir} -lib ${RPM_BUILD_ROOT}%{_libdir} -option USE_PERL_VERSION=5.16 -option USE_PYTHON_VERSION=%{python_version} -acceptlicense -verbose
./STAFInst -target ${STAF_ROOT} -option USE_PERL_VERSION=5.%{perlversion} -option USE_PYTHON_VERSION=%{python_version} -acceptlicense -verbose
#cp -a lib/jython ${STAF_ROOT}/lib
#symlinks -rcd ${RPM_BUILD_ROOT}%{_bindir}
#symlinks -rcd ${RPM_BUILD_ROOT}%{_libdir}
symlinks -rcd ${STAF_ROOT}
cd ${STAF_ROOT}
for i in *.sh; do
    mv ${i} ${i}.old
    sed -e "s@${RPM_BUILD_ROOT}@@g" ${i}.old > ${i}
    rm -f ${i}.old
done
chmod 755 ${STAF_ROOT}/startSTAFProc.sh
rm -f ${STAF_ROOT}/STAFUninst
rm -f ${STAF_ROOT}/lib/lib{ssl,crypto}*

%if 0%{?rhel} == 5
mkdir -p ${RPM_BUILD_ROOT}%{_initrddir}
sed -e 's:@STAF_HOME@:%{_libdir}/staf:' %{SOURCE2} > ${RPM_BUILD_ROOT}%{_initrddir}/%{service_name}
chmod 755 ${RPM_BUILD_ROOT}%{_initrddir}/%{service_name}
%else
mkdir -p ${RPM_BUILD_ROOT}%{_unitdir}
sed -e 's:@LIBDIR@:%{_libdir}:' %{SOURCE1} > ${RPM_BUILD_ROOT}%{_unitdir}/%{service_name}.service
chmod 644 ${RPM_BUILD_ROOT}%{_unitdir}/%{service_name}.service
%endif

mkdir -p ${RPM_BUILD_ROOT}%{perl_vendorarch}
for f in ${STAF_ROOT}/bin/*.pm; do
    bname=$(basename $f)
    ln -v -s ../../staf/bin/$bname ${RPM_BUILD_ROOT}%{perl_vendorarch}/$bname
done

mkdir -p ${RPM_BUILD_ROOT}/etc/profile.d/
ln -v -s ../..%{_libdir}/staf/STAFEnv.sh ${RPM_BUILD_ROOT}/etc/profile.d/
mkdir -p ${STAF_ROOT}/services
#ln -v -s staf/lib/libPLSTAF.so ${RPM_BUILD_ROOT}%{_libdir}/libPLSTAF.so
#ln -v -s ../../perl5/CORE/libperl.so ${STAF_ROOT}/lib/libperl.so
sed -i -e 's:STAFEnv.sh:STAFEnv.sh\nexport LD_PRELOAD=%{perl_archlib}/CORE/libperl.so\nexport LD_LIBRARY_PATH=%{perl_archlib}/CORE\:${LD_LIBRARY_PATH\:-}:' ${STAF_ROOT}/startSTAFProc.sh


%post
#/sbin/ldconfig
%if 0%{?rhel} == 5
/sbin/chkconfig --add %{service_name}
%else
%systemd_post %{service_name}.service
%endif

%preun
%if 0%{?rhel} == 5
if [ $1 -eq 0 ] ; then
    /sbin/service %{service_name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{service_name}
fi
%else
%systemd_preun %{service_name}.service
%endif

%postun
#/sbin/ldconfig
%if 0%{?rhel} == 5
if [ "$1" -ge "1" ] ; then
    /sbin/service %{service_name} condrestart >/dev/null 2>&1 || :
fi
%else
%systemd_postun_with_restart %{service_name}.service
%endif

%files
/etc/profile.d/*
%{_libdir}/staf
#%{_libdir}/*so*
%{perl_vendorarch}/*

%if 0%{?rhel} == 5
%{_initrddir}/%{service_name}
%else
%{_unitdir}/%{service_name}.service
%endif
#/etc/ld.so.conf.d/STAF.conf

%changelog
* Tue Mar 14 2017 Li Rui Bin <lirb@winhong.com> - 3.4.26-4
- Support el5

* Fri Mar 10 2017 Li Rui Bin <lirb@winhong.com> - 3.4.26-3
- Support ix86

* Mon Mar  6 2017 Li Rui Bin <lirb@winhong.com> - 3.4.26-1
- Update to 3.4.26
